/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ascass.solving;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author erich
 */
public class AspSolver {
    //private String ground = "";
    private String answerSet = "";
    private String source = "";
    //private boolean grounded = false;
    private String claspOutput = "";
    private String csp = "";
    private int num = 1;
    private int numas;
    public boolean complete; 
    public int timeout = -1;

    public AspSolver(String source) {
        this.source = source;
    }

    public String getCsp() {
        return csp;
    }
    
    public String getSource() {
        return this.source;
    }
    
    public String getClaspOutput() {
        return this.claspOutput;
    }
    
    public String getAnswerSet() {
        return answerSet;
    }
    
    public boolean nextAnswerSet() throws Exception{     
        this.answerSet = Filter.getFilteredAS(this.claspOutput,this.num);
        if(!this.answerSet.equals("")){  
            //System.out.println("as:");
            //System.out.println(this.answerSet);
            //System.out.println("endas:");
            
            this.csp = Filter.getFilteredCSP(this.answerSet);
            this.num++;
            return true;
        }else{
            if(this.numas!=0 && this.num>this.numas){
                this.complete = false;
            }
            else{
                this.complete = true;
            }
            
            return false;   
        }
    }
    
    private int getNumAs(){
        Pattern pattern = Pattern.compile("aspnumas\\((.*?)\\)");
        Matcher matcher = pattern.matcher(this.source);
        if (matcher.find()){
            this.numas = Integer.parseInt(matcher.group(1));
            System.out.println("max num answer sets:"+this.numas);
            return this.numas;
        }
        System.out.println("default max num answer sets:1");
        this.numas = 1;
        return 1;
    }
    
    private String getAspHeuristic(){
        Pattern pattern = Pattern.compile("aspheuristic\\((.*?)\\)");
        Matcher matcher = pattern.matcher(this.source);
        if (matcher.find()){
            System.out.println("asp heuristic:"+matcher.group(1));
            return " --heu=" + matcher.group(1);
        }
        System.out.println("asp heuristic:vsids");
        return " --heu=vsids";
    }
    
    private String getAspTimeout(){
        Pattern pattern = Pattern.compile("asptimeout\\((.*?)\\)");
        Matcher matcher = pattern.matcher(this.source);
        if (matcher.find()){
            System.out.println("asp timeout:"+matcher.group(1));
            this.timeout = Integer.parseInt(matcher.group(1));
            return " --time-limit="+matcher.group(1);
        }
        System.out.println("no asp timeout");
        this.timeout = -1;
        return "";
    }
    
    public boolean solve() throws Exception{
        this.num = 1;
        Runtime rt = Runtime.getRuntime();
        Process pr = null;
        
        try{
            pr = rt.exec((new File(".").getCanonicalPath())+"/clingo.exe "+getNumAs() + getAspHeuristic() + getAspTimeout());
        }catch(Exception e){
            System.err.println(e.getMessage());
            pr = rt.exec((new File(".").getCanonicalPath())+"/clingo "+getNumAs() + getAspHeuristic() + getAspTimeout());
        }
        
        BufferedReader input = new BufferedReader(new InputStreamReader(pr.getInputStream()));
        BufferedReader error = new BufferedReader(new InputStreamReader(pr.getErrorStream()));
        BufferedWriter output = new BufferedWriter(new OutputStreamWriter(pr.getOutputStream()));

        output.write(this.source);
        output.close();

        String line = null;
        this.claspOutput = "";
        
        while ((line = input.readLine()) != null) {
            this.claspOutput += line;
        }
        
        while ((line = error.readLine()) != null) {
            this.claspOutput += line;
        }

        pr.waitFor();
        input.close();
        error.close();
        
        if(this.claspOutput.contains("Answer: "+1)){
            return true;
        }
        else{
            return false;
        }
    }    
}
