
package ascass.solving;

import org.jacop.constraints.PrimitiveConstraint;
import org.jacop.core.Var;
import org.jacop.search.ExitChildListener;
import java.util.HashMap;

public class MyLimited<T extends Var> implements ExitChildListener<T> {
    boolean timeOut = false;
    int defaultLimit = Integer.MAX_VALUE;
    HashMap<T,Integer> limitMap = new HashMap();
    HashMap<T,Integer> countMap = new HashMap();

    public MyLimited() {

    }

    public void setDefault(int defaultLimit) {
            assert (defaultLimit >= 0);
            this.defaultLimit = defaultLimit;
    }

    public void setVariable(T var, int i){
        this.limitMap.put(var, i);
    }

    @Override
    public boolean leftChild(T var, int value, boolean status) {
        if (!status) {
            
            Integer count = this.countMap.get(var);
            if(count==null){
                count = 0;
            }
            
            count = count+1;
            this.countMap.put(var, count);
            
            Integer limit = this.limitMap.get(var);
            if(limit==null){
                limit = this.defaultLimit;
            }

            //System.out.println(var.id+"("+value+")"+": limit="+limit+" count="+count);

            if (count >= limit) {
                count = count -1;
                this.countMap.put(var, count);
                return false;

            } else {
                return true;

            }
        }

        return status;

    }

    @Override
    public void rightChild(T var, int value, boolean status) {
        Integer count = this.countMap.get(var);
        count = count -1;
        this.countMap.put(var, count);
    }

    
    
    
    //not needed in ASCASS
    @Override
    public boolean leftChild(PrimitiveConstraint choice, boolean status){
            throw new RuntimeException("MyLimited: Not implemented!");
    }

    @Override
    public void rightChild(PrimitiveConstraint choice, boolean status) {
        throw new RuntimeException("MyLimited: Not implemented!");
    }

    @Override
    public void setChildrenListeners(ExitChildListener<T>[] children) {
        throw new RuntimeException("MyLimited: Not implemented!");
    }

    @Override
    public void setChildrenListeners(ExitChildListener<T> child) {
        throw new RuntimeException("MyLimited: Not implemented!");
    }

}
