/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ascass.solving;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.TreeMap;
import org.antlr.v4.runtime.misc.NotNull;
import org.jacop.core.IntVar;
import ascass.parsing.HcaspParser;

/**
 *
 * @author erich
 */
public class VarVectors {
    private TreeMap<Integer,TreeMap> map = new TreeMap();
    private HashMap<String,ArrayList> cache = new HashMap();
            
    public VarVectors() {
    }
    
    public void addVariable(@NotNull HcaspParser.VarsetContext ctx, IntVar v){        
        List<HcaspParser.ArgContext> args = ctx.arg();
        
        
        TreeMap<String,TreeMap> arity = map.get(args.size());
        if(arity == null){
            //System.out.println("new treemap for arity = " + args.size());
            arity = new TreeMap();
            map.put(args.size(), arity);
        }
        
        TreeMap name = arity.get(ctx.CONST().getText());
        if(name == null){
            //System.out.println("new treemap for name = " + ctx.CONST().getText());
            name = new TreeMap(new NaturalOrderComparator());
            arity.put(ctx.CONST().getText(), name);
        }
        
        TreeMap run = name;
        Object arg;
        String argstr;
        for(int i = 0; i < args.size()-1; i++){
            argstr = args.get(i).getText();
            arg = run.get(argstr);
            if(arg == null){
                //System.out.println("new treemap for arg = " + argstr);
                arg = new TreeMap(new NaturalOrderComparator());
                run.put(argstr, arg);
            }
            run = (TreeMap)arg;
        }
        
        //System.out.println("VarVectos.addVariable:"+ctx.getText()+" key:"+args.get(args.size()-1).getText());
        run.put(args.get(args.size()-1).getText(), v);
    }
    
    public IntVar[] getVariableVector(@NotNull HcaspParser.VarsetContext ctx){
        //System.out.println("VarVectos.getVariableVector:"+ctx.getText());
        ArrayList<IntVar> ret = this.cache.get(ctx.getText());
        if(ret != null){
            if(ret.isEmpty()){
                System.out.println("cache empty:"+ctx.getText());
                return null;
            }
            return ret.toArray(new IntVar[ret.size()]);
        }
        
        List<HcaspParser.ArgContext> args = ctx.arg();
        
        TreeMap run = map.get(args.size());
        if(run == null){
            //System.out.println("unseen num args:"+ctx.getText());
            return null;
        }
        
        run = (TreeMap)run.get(ctx.CONST().getText());
        if(run == null){
            //System.out.println("unseen name:"+ctx.getText());
            return null;
        }
        
        ret = mapWalker(run,args);
        this.cache.put(ctx.getText(), ret);
        
        
        if(ret.isEmpty()){
            //System.out.println("map walker finds nothing:"+ctx.getText());
            return null;
        }
        
        return ret.toArray(new IntVar[ret.size()]);
        
    }
    
    private ArrayList<IntVar> mapWalker(TreeMap m, List<HcaspParser.ArgContext> args){
        ArrayList<IntVar> ret = new ArrayList();
        //System.out.println("map walker: args.size = "+args.size());
        if(m == null){
            System.out.println("map walker: m==null");
            return ret;
        }
        
        if(args.size() > 1){
            List<HcaspParser.ArgContext> sub = new ArrayList();
            for(int i = 1; i < args.size(); i++){
                sub.add(args.get(i));
            }
            
            if(args.get(0).all() == null){  
                ret = mapWalker((TreeMap)m.get(args.get(0).getText()),sub);
            }
            else{
                for(Iterator iter = m.values().iterator(); iter.hasNext();){
                    ret.addAll(mapWalker((TreeMap)iter.next(),sub));
                }  
            }
        }
        else{//args.size() == 1
            if(args.get(0).all() == null){
                Object obj = m.get(args.get(0).getText());
                if(obj != null){
                    ret.add((IntVar)obj);
                }
                else{
                    //System.out.println("no key:"+args.get(0).getText());
                }
            }
            else{
                for(Iterator iter = m.values().iterator(); iter.hasNext();){
                    ret.add((IntVar)iter.next());
                }  
            }
        }
        
        return ret;
    }
}
