package checkers;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;

import coders.Constants;
import coders.Decoder;
import coders.Decoder_IncrementalScheduling;
import ascass.solving.CaspSolver;
import scheduler.Group;
import scheduler.Scheduler;

public class Checker_IncrementalScheduling extends Checker{
	
	
	private static final String INTERNALCHECKERPATH= "/ascass/checkers/checker.lp";
	
	Decoder decoder;

	public Checker_IncrementalScheduling(Scheduler scheduler) {
		super(scheduler);
		decoder= new Decoder_IncrementalScheduling(scheduler);
		// TODO Auto-generated constructor stub
	}

	@Override
	public int check() {


		System.out.println("checker start");
		String input,program = null;
		String currentFolder = "";
		
		File ascassSolverFile = null;
		File heuristicFile;
		try {
			currentFolder = new File(".").getCanonicalPath();
			ascassSolverFile= new File(currentFolder+INTERNALCHECKERPATH);
			program = FileUtils.readFileToString(ascassSolverFile);
		
			
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		String outputString = currentFolder + Constants.OUTPUTFOLDER;
		
		
		int solution;
		input = program;
		input += decoder.decode();
		input += decoder.decodeSolutionAtoms();
		//System.out.println(input);	
		caspSolver = new CaspSolver(input);

			solution = 0;
			try {
				solution = caspSolver.calcSolution();

			} catch (Exception e) {
				e.printStackTrace();
			}

			// if (solver.getStore() != null)
			switch (solution) {
			case -2:
				System.out.println("no solution found:" + solution);
				return -2;
			case -1:
				System.out.println("no solution found:" + solution);
				return -1;
			case 0:
				System.out.println("Unsatisfiable");
				return 0;
			default:
				String report=caspSolver.getAspSolver().getAnswerSet();
			
				if (report.contains("err")){
					System.out.println(report);
					return 0;
				}else{
					System.out.println("No errors detected");
					return 1;
				}
			
				
			}
		}

	
	

	
	
}