package coders;


import java.io.File;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.LineIterator;

import ascass.solving.CaspSolver;
import scheduler.Group;
import scheduler.Job;
import scheduler.Machine;
import scheduler.Scheduler;


public abstract class Decoder{
	

	/** The scheduler to which the solver is attached. A solver can be attached to one Scheduler*/
	protected Scheduler scheduler;

											



	public Decoder(Scheduler scheduler){
		
		this.scheduler=scheduler;
		
	}


	

	
	/**
	 * Gets the scheduler binded with this Solver
	 *
	 * @return the scheduler
	 */
	public Scheduler getScheduler() {
		return scheduler;
	}





	/**
	 * This method must be implemented for every class that extends the {@link Solver Solver class}
	 *
	 * @return the int
	 */
	public abstract String decode();





	public abstract String decodeSolution();





	public abstract String decode(Group g);





	public String decodeSolutionAtoms() {
		// TODO Auto-generated method stub
		return null;
	}


	






} // SolverImpl
