package launchers;

import java.io.File;

import checkers.Checker;
import checkers.Checker_IncrementalScheduling;
import scheduler.Scheduler;
import solvers.Solver;
import solvers.Cumulative_IncrementalScheduling;
import splitters.Lotwise_IncrementalScheduling;
import splitters.Machinewise_IncrementalScheduling;
import splitters.Typewise_IncrementalScheduling;

public class FirstLauncher {

	
	
	private static final String INPUTFOLDER="/input/";
	
	private static final String OUTPUTFOLDER="/output/";

	
	static String outputString = "";
	static String filename = "";
	static String currentFolder = null;

	
	public static void main(String[] args) {



		outputString = "";
		filename = "";
		currentFolder = null;
		try {

			currentFolder = new File(".").getCanonicalPath();
			System.out.println(currentFolder);
			outputString = currentFolder + OUTPUTFOLDER;
			filename = outputString + "SolverCTnewEncoding";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();

		}
		// for every input

			File f = new File(currentFolder + INPUTFOLDER
					+ "/firstTest");
			int[] factors={10};
			for (File j : f.listFiles())
				if (j.isFile()) {
					for (int i : factors) {
						System.out.println("NEW VERSION 1"+j.getAbsolutePath());
						Scheduler s = new Scheduler(j.getAbsolutePath());
						printResults( s, j.getName().substring(0, j.getName().length()-4),i);
						//Printer.generateCsvFileStartStop(outputString+ "ganttchart.csv", s);
					}
				}

		

	}

	private static void printResults( Scheduler s, String title,int d) {
			
			
			System.out.println("___________________________________");
			System.out.println("___________"+title+ " factor= "+d+" is started___________");
			
			
			s.parseInput();
			//s.printMachines();
			s.setSplitter(new Machinewise_IncrementalScheduling(s));
			s.getSplitter().split();
			s.PrintGroups();
			/*s.setSolver(new Cumulative_IncrementalScheduling(s));
			s.getSolver().setPrintInfo(true);
			s.getSolver().solve();
			//s.printAllContent();
			s.setChecker(new Checker_IncrementalScheduling(s));
			s.getChecker().check();
			System.out.println("makespan= "+s.getMakeSpan());
	
			System.out.println("off the optimum= "+((s.getMakeSpan()-600000)/6000) +"%");*/
		}
}
