package scheduler;


/**
 * <!-- begin-user-doc -->
 * The '<em><b>Changeover</b></em>' class specifies the parameters of the changeover in the Infineon case.
 * Since there is no changeover in the Incremental scheduling problem, this class is relevant just for the Infineon scheduling problem. 
 * '<em><b>type1</b></em>' and '<em><b>type2</b></em>' are '<em><b>JobType</b></em>'s that identifies the changeover. 
 * Since the changeover is simmetric, the types are lexicographically ordered. in this way there is no difference between changeover(t1,t2) and changeover(t2,t1).
 * <!-- end-user-doc -->
 */
public class Changeover {

	private JobType type1;
	private JobType type2;
	private int length;
	
	public Changeover(JobType t1,JobType t2, int length){
		
		if(t1.compareTo(t2)<1){
			this.type1=t1;
			this.type2=t2;
		}
		else{
			this.type1=t2;
			this.type2=t1;
		}
		this.length=length;
	}


	public JobType getType1() {
		return type1;
	}


	public JobType getType2() {
		return type2;
	}


	public int getLength() {
		return length;
	}


	public String toString(){
		return type1.toString()+"-"+type2.toString();
	}

	
	public static String generateKey(JobType t1,JobType t2){
		if(t1.compareTo(t2)<1)
			return t1.toString()+"-"+t2.toString();
		else
			return t2.toString()+"-"+t1.toString();
		
	}


}
