
package scheduler;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import coders.Constants;
import scheduler.Changeover;
import scheduler.Group;
import scheduler.Job;
import scheduler.JobType;
import scheduler.Machine;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Group</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link scheduler.impl.GroupImpl#getId <em>Id</em>}</li>
 *   <li>{@link scheduler.impl.GroupImpl#getJobsInGroup <em>Jobs In Group</em>}</li>
 *   <li>{@link scheduler.impl.GroupImpl#getMachineInGroup <em>Machine In Group</em>}</li>
 *   <li>{@link scheduler.impl.GroupImpl#getChangeover <em>Changeover</em>}</li>
 * </ul>
 * </p>
 *

 */
public class Group{

	protected static final int ID_DEFAULT = -1;

	
	protected int id = ID_DEFAULT;

	
	protected List<Job> jobsInGroup;


	protected List<Machine> machineInGroup;

	

	
	protected List<Changeover> changeover;


	
	
	public Group(int id) {
		this.id=id;
		changeover=new ArrayList<Changeover>();
		jobsInGroup= new ArrayList<Job>();
		machineInGroup= new ArrayList<Machine>();
	}

	

	public int getId() {
		return id;
	}

	


	public List<Job> getJobsInGroup() {
		return jobsInGroup;
	}

	
	public List<JobType> getTypesInGroup() {
		List<JobType> l=new ArrayList<JobType>();
		for (Job j : getJobsInGroup())
			l.add(j.getType());
		
		return l;
	}
	
	

	public List<Machine> getMachinesInGroup() {
	
		return machineInGroup;
	}


	public List<Changeover> getChangeover() {
		return changeover;
	}


	@Override
	public String toString() {
	

		StringBuffer result = new StringBuffer("Group= ");
		result.append(" (id: ");
		result.append(id);
		result.append(", JOBS: ");
		result.append(jobsInGroup.size());
		result.append(", MACHINES: ");
		result.append(machineInGroup.size());
		result.append(", CHANGEOVERS: ");
		result.append(getChangeover().size()+").");
		return result.toString();
	}



	

	

} //GroupImpl
